<?php

namespace WPT_Divi_Product_Carousel_Modules\DiviProductCarouselModule;

use  ET_Builder_Module ;
use  ET_Builder_Element ;
/**
 * DiviProductCarouselModule.
 */
class DiviProductCarouselModule extends ET_Builder_Module
{
    public  $main_css_element = 'section%%order_class%%' ;
    public  $name = 'Product Carousel' ;
    public  $slug = 'et_pb_wptools_product_carousel' ;
    public  $vb_support = 'on' ;
    protected  $container ;
    protected  $module_credits = array(
        'module_uri' => 'https://wptools.app',
        'author'     => 'WP Tools',
        'author_uri' => 'https://wptools.app',
    ) ;
    /**
     * Constructor.
     */
    public function __construct( $container )
    {
        $this->container = $container;
        parent::__construct();
    }
    
    /**
     * Advanced fields.
     */
    public function get_advanced_fields_config()
    {
        if ( wptools_product_carousel_fs()->is_free_plan() ) {
            return [
                'border'                => false,
                'borders'               => false,
                'text'                  => false,
                'box_shadow'            => false,
                'filters'               => false,
                'animation'             => false,
                'text_shadow'           => false,
                'max_width'             => false,
                'margin_padding'        => false,
                'custom_margin_padding' => false,
                'background'            => false,
                'fonts'                 => false,
                'link_options'          => false,
            ];
        }
    }
    
    /**
     * Premium advanced fields
     *
     * @return [type] [description]
     */
    public function get_advanced_fields_config__premium()
    {
        return [
            'borders'        => [
            'default' => [
            'css'         => [
            'main' => [
            'border_styles' => "{$this->main_css_element} div.slick-slide",
            'border_radii'  => "{$this->main_css_element} div.slick-slide",
        ],
        ],
            'defaults'    => [
            'border_radii'  => 'on|10px|10px|10px|10px',
            'border_styles' => [
            'width' => '0px',
            'color' => '#ffffffff',
            'style' => 'solid',
        ],
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'carousel_image',
        ],
        ],
            'text'           => false,
            'box_shadow'     => [
            'default' => [
            'css'         => [
            'main'      => "{$this->main_css_element} div.slick-slide",
            'important' => 'all',
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'carousel_image',
        ],
        ],
            'filters'        => [
            'css' => [
            'main'        => '%%order_class%% div.slick-slide',
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'carousel_image',
        ],
        ],
            'animation'      => false,
            'text_shadow'    => false,
            'max_width'      => false,
            'custom_margin'  => false,
            'margin_padding' => false,
            'background'     => false,
            'fonts'          => [
            'blog_title' => [
            'sub_toggle'  => 'blog_title',
            'css'         => [
            'main' => "{$this->main_css_element} article h4",
        ],
            'text_align'  => [
            'default' => 'center',
        ],
            'font'        => [
            'default' => '|700',
        ],
            'line_height' => [
            'default' => '1.3em',
        ],
            'font_size'   => [
            'default' => '18px',
        ],
        ],
        ],
            'link_options'   => false,
        ];
    }
    
    /**
     * Custom css fields.
     */
    public function get_custom_css_fields_config()
    {
        return [];
    }
    
    /**
     * Premium Custom css fields.
     *
     * @return [type] [description]
     */
    public function get_custom_css_fields_config__premium()
    {
        return [
            'blog_container'                => [
            'label'    => esc_html__( 'Product Container (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% div.blog-carousel-item',
        ],
            'image_container'               => [
            'label'    => esc_html__( 'Image Container (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% div.carousel-item div.blog-carousel-item  div.wpt-post-thumbnail',
        ],
            'featured_image'                => [
            'label'    => esc_html__( 'Featured Image (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% div.carousel-item div.blog-carousel-item  div.wpt-post-thumbnail img',
        ],
            'title_container'               => [
            'label'    => esc_html__( 'Title Container (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% div.carousel-item div.blog-carousel-item  div.text',
        ],
            'title_container'               => [
            'label'    => esc_html__( 'Title (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% div.carousel-item div.blog-carousel-item  div.text h4',
        ],
            'arrows_navigation'             => [
            'label'    => esc_html__( 'Arrows Navigation (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-arrow',
        ],
            'arrows_navigation_before'      => [
            'label'    => esc_html__( 'Arrows Navigation :before (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-arrow:before',
        ],
            'dots_navigation'               => [
            'label'    => esc_html__( 'Dots Navigation (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-dots li button',
        ],
            'dots_navigation_before'        => [
            'label'    => esc_html__( 'Dots Navigation :before (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-dots li button:before',
        ],
            'dots_active_navigation'        => [
            'label'    => esc_html__( 'Dots Active Navigation (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-dots li.slick-active button',
        ],
            'dots_active_navigation_before' => [
            'label'    => esc_html__( 'Dots Active Navigation :before (Premium)', $this->container['slug'] ),
            'selector' => '%%order_class%% .slick-dots li.slick-active button:before',
        ],
        ];
    }
    
    /**
     * Divi module fields.
     *
     * @return [type] [description]
     */
    public function get_fields()
    {
        return $this->container['carousel_module_fields']->get_fields();
    }
    
    /**
     * Settings modal toggle
     *
     * @return [type] [description]
     */
    public function get_settings_modal_toggles()
    {
        $toggles = $this->get_settings_modal_toggles__free();
        return $toggles;
    }
    
    /**
     * Freely available options.
     */
    public function get_settings_modal_toggles__free()
    {
        return [
            'general' => [
            'toggles' => [
            'main_content' => esc_html__( 'Carousel General Settings', 'et_builder' ),
        ],
        ],
        ];
    }
    
    /**
     * Premium toggle options.
     */
    public function get_settings_modal_toggles__premium( $toggles )
    {
        $toggles['general']['toggles']['responsive'] = esc_html__( 'Carousel Responsive Settings (Premium)', 'et_builder' );
        $toggles['general']['toggles']['motion'] = esc_html__( 'Carousel Motion Settings (Premium)', 'et_builder' );
        $toggles['general']['toggles']['navigation'] = [
            'title' => esc_html__( 'Carousel Navigation Settings (Premium)', 'et_builder' ),
        ];
        $toggles['advanced'] = [
            'toggles' => [
            'blog_title'          => esc_html__( 'Product Title (Premium)', 'et_builder' ),
            'carousel_image'      => esc_html__( 'Carousel Slide (Premium)', 'et_builder' ),
            'carousel_navigation' => [
            'title'             => esc_html__( 'Carousel Navigation (Premium)', 'et_builder' ),
            'tabbed_subtoggles' => true,
            'sub_toggles'       => [
            'arrows_navigation' => [
            'name' => esc_html__( 'Arrows', 'et_builder' ),
        ],
            'dots_navigation'   => [
            'name' => esc_html__( 'Dots', 'et_builder' ),
        ],
        ],
        ],
        ],
        ];
        return $toggles;
    }
    
    /**
     * Init
     *
     * @return [type] [description]
     */
    public function init()
    {
        $this->child_item_text = esc_html__( 'Blog Item', 'et_builder' );
        $this->child_slug = 'et_pb_wptools_carousel_product_item';
    }
    
    /**
     * Render function
     *
     * @param  [type] $unprocessed_props [description]
     * @param  [type] $content           [description]
     * @param  [type] $render_slug       [description]
     * @return [type] [description]
     */
    public function render( $unprocessed_props, $content = null, $render_slug )
    {
        // wp_die(var_dump($this->props, $unprocessed_props));
        $module_classes = $this->module_classname( $render_slug );
        $module_class = trim( ET_Builder_Element::add_module_order_class( '', $render_slug ) );
        $defaults = wp_parse_args( $unprocessed_props, $this->container['carousel_module_fields']->get_defaults() );
        foreach ( $defaults as $key => $value ) {
            if ( isset( $this->props[$key] ) and empty($this->props[$key]) ) {
                $this->props[$key] = $value;
            }
        }
        $props = wp_parse_args( $this->props, $defaults );
        // wp_die(json_encode($props));
        $this->container[$render_slug] = $props;
        $this->container['divi']->enqueue_carousel_blog_module_assets();
        $main_selector = 'section.' . $module_class;
        
        if ( isset(
            $_POST['object'],
            $_POST['object'][0],
            $_POST['object'][0]['attrs'],
            $_POST['object'][0]['attrs']['content']
        ) and is_array( $_POST['object'][0]['attrs']['content'] ) ) {
            $module_class = '.' . $render_slug . '_' . $_POST['et_fb_module_index'];
            $children_html = '';
            foreach ( $_POST['object'][0]['attrs']['content'] as $child_item ) {
                if ( isset( $child_item['props']['attrs']['blog_id'] ) ) {
                    $children_html .= $this->container['post']->render_post_item( $child_item['props']['attrs']['blog_id'] );
                }
            }
            $content = $children_html;
        } else {
            $content = $this->content;
        }
        
        //in-line style
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "{$main_selector} .slick-arrow:before",
            'declaration' => sprintf( 'color:%s', $props['arrows_background'] ),
        ] );
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "{$main_selector} .slick-arrow",
            'declaration' => 'cursor:pointer !important;',
        ] );
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "{$main_selector} .slick-dots li button:before",
            'declaration' => sprintf( 'opacity: 1!important;color:%s', $props['dots_background'] ),
        ] );
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "{$main_selector} .slick-dots li.slick-active button:before",
            'declaration' => sprintf( 'opacity: 1!important;color:%s', $props['dots_active_background'] ),
        ] );
        if ( wptools_product_carousel_fs()->is_free_plan() ) {
            ET_Builder_Element::set_style( $render_slug, [
                'selector'    => "{$main_selector} div.slick-slide",
                'declaration' => 'box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.2), 0 1px 2px 0 rgba(0, 0, 0, 0.2)',
            ] );
        }
        ob_start();
        require $this->container['dir'] . '/resources/views/wptools-divi-carousel-blogs.php';
        return ob_get_clean();
    }

}